/*
 * Combination.java
 * Java
 */

package samples;

/**
 * A sample that computes factorial(n) and combination(n,p)
 */
public class Combination
{
	private int	myN, myP;
	
    public Combination(int n, int p)
    {
    	myN = n;
    	myP = p;
    }

 	public long factorial(int n)
 	{
		return (n <= 1) ? 1 : n*factorial(n-1);	// he-he... let's mix a ternary operator (?) and recursion...
	}
	
	public long combination(int n, int p)
	{
 		return factorial(n) / (factorial(n - p) * factorial(p));
	}
	
    public void go()
    {
		System.out.println("Combination>Java");
	    System.out.println();
		System.out.println("factorial(" + myN + ") = " + factorial(myN));
		System.out.println("factorial(" + myP + ") = " + factorial(myP));
		System.out.println("factorial(" + (myN-myP) + ") = " + factorial(myN-myP));
		System.out.println("combination(" + myN + "," + myP + ") = " + combination(myN, myP));
	}

    public static void main(String[] args)
    {
		if (args.length != 2)
		{
			System.err.println("Usage: Combination n p");
			System.exit(0);
		}

		int	argN = java.lang.Integer.parseInt(args[0]),
			argP = java.lang.Integer.parseInt(args[1]);

    	Combination	comb = new Combination(argN, argP);
    	comb.go();
    }
}

